import boto3
import paramiko
import time,shlex
import subprocess as sp
import random
import os
import sys
import shutil
import statistics
FNULL = open(os.devnull, 'w')


def start_ec2(ec2_name):
    ec2_client = boto3.client("ec2")
    instance=ec2_client.run_instances(ImageId=ImageId_with_docker, MinCount=1, MaxCount=1, 
                                      InstanceType=ec2_name, KeyName="rohan",
                                      SecurityGroupIds=["sg-0862ddd686981521a"],
                                      SecurityGroups=["ec2-basic"])
    return (instance["Instances"][0]["InstanceId"])


def terminate_ec2(he, le):
    ec2 = boto3.resource('ec2')
    instance = ec2.Instance(he)
    instance.terminate()
    instance = ec2.Instance(le)
    instance.terminate()


def ssh_connect_with_retry_with_run(ssh, ip_address, retries,app):
    if retries > 3:
        return False
    privkey = paramiko.RSAKey.from_private_key_file(keypath)
    interval = 5
    try:
        retries += 1
        print('SSH into the instance: {}'.format(ip_address))
        ssh.connect(hostname=ip_address, timeout=7200, username='ubuntu', pkey=privkey)
        #return True
    except Exception as e:
        print(e)
        time.sleep(interval)
        print('Retrying SSH connection to {}'.format(ip_address))
        ssh_connect_with_retry_with_run(ssh, ip_address, retries, app)
    print("connected")
    t1=time.time()
    stdin, stdout, stderr = ssh.exec_command("sudo docker run "+app)
    t2=time.time()
    stdin, stdout, stderr = ssh.exec_command("sudo docker run "+app)
    t3=time.time()
    exit_status = stdout.channel.recv_exit_status()
    return t2-t1, t3-t2


if __name__ == "__main__":
	ImageId_with_docker='ami-0d9e05e19496caf64' ##
	high_end_vm_family='m5n.4xlarge' ##
	low_end_vm_family='m5a.4xlarge' ##
	keypath='/home/rohan/rohan.pem' ##
	app= "cloudsuite/graph-analytics:4.0" ##
	high_end_server_instance_id = start_ec2(high_end_vm_family)
	low_end_server_instance_id = start_ec2(low_end_vm_family)


	ec2 = boto3.resource('ec2', region_name='us-east-2')
	current_instance = list(ec2.instances.filter(InstanceIds=[high_end_server_instance_id]))
	ip_address = current_instance[0].public_ip_address
	ssh = paramiko.SSHClient()
	ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
	a,b=ssh_connect_with_retry_with_run(ssh, ip_address, 2,app)
	exe_time_costly=b
	cs_time_costly=a-b

	current_instance = list(ec2.instances.filter(InstanceIds=[low_end_server_instance_id]))
	ip_address = current_instance[0].public_ip_address
	ssh = paramiko.SSHClient()
	ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
	a,b=ssh_connect_with_retry_with_run(ssh, ip_address, 2,app)
	exe_time_cheap=b
	cs_time_cheap=a-b

	terminate_ec2(high_end_server_instance_id,low_end_server_instance_id)
	print("exe_time_costly = ", exe_time_costly)
	print("exe_time_cheap = ", exe_time_cheap)
	print("cs_time_costly = ", cs_time_costly)
	print("cs_time_cheap = ", cs_time_cheap)
