import matplotlib.pyplot as plt
import statistics
import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.pyplot as mp
import numpy as np
from matplotlib import rcParams
import statistics
rcParams['font.family'] = 'serif'
rcParams['font.sans-serif'] = ['Roboto']

def read_data(basedir):
    dir_name=[]
    for item in med_trace_list:
        dir_name.append("/med_"+str(item))
    for item in tail_trace_list:
        dir_name.append("/tail_"+str(item))
                       
    keepalive = []
    time = []
                        
    for item in dir_name:
        filename=basedir+item+"/keepalive_cost_list.txt"
        with open(filename) as f:
            l_list=f.read().splitlines()
            l_list=[float(i) for i in l_list]
        keepalive.append(l_list)
        
        filename=basedir+item+"/time_list.txt"
        with open(filename) as f:
            l_list=f.read().splitlines()
            l_list=[float(i) for i in l_list]
        time.append(l_list)
        
    return(keepalive, time)


med_trace_list = [249, 757, 1385, 1489, 1717, 1721] 
tail_trace_list = [9,15,18,19,21,22]


# count_cost_list=  [20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0]
# count_cheap_list= [0,2,4,5,7,9,11,12,14,16,18,19,21,23,25,26,28,30,32,33,35]


count_cost_list=  [20,18,16,14,12,10,8,6,4,2,0]
count_cheap_list= [0,4,7,11,14,18,21,25,28,32,35]
    

keepalive_openwhisk_imp=[]
keepalive_technique_imp=[]
keepalive_wild_imp=[]
keepalive_faascache_imp=[]
keepalive_timeoracle_imp=[]

time_openwhisk_imp=[]
time_technique_imp=[]
time_wild_imp=[]
time_faascache_imp=[]
time_timeoracle_imp=[]


time_time=[]
keepalive_keepalive=[]

for n_num in range(len(count_cheap_list)):
    keepalive_openwhisk, time_openwhisk = read_data("./results/cost"+str(count_cost_list[n_num])+"cheap"+str(count_cheap_list[n_num])+"/openwhisk")
    keepalive_technique, time_technique = read_data("./results/cost"+str(count_cost_list[n_num])+"cheap"+str(count_cheap_list[n_num])+"/technique")
    keepalive_wild, time_wild = read_data("./results/cost"+str(count_cost_list[n_num])+"cheap"+str(count_cheap_list[n_num])+"/wild")
    keepalive_faascache, time_faascache = read_data("./results/cost"+str(count_cost_list[n_num])+"cheap"+str(count_cheap_list[n_num])+"/faascache")
    keepalive_timeoracle, time_timeoracle = read_data("./results/cost"+str(count_cost_list[n_num])+"cheap"+str(count_cheap_list[n_num])+"/timeoracle")
    
    keepalive_openwhisk_list=[statistics.mean(i) for i in keepalive_openwhisk]
    time_openwhisk_list=[statistics.mean(i) for i in time_openwhisk]
    keepalive_technique_list=[statistics.mean(i) for i in keepalive_technique]
    time_technique_list=[statistics.mean(i) for i in time_technique]
    keepalive_wild_list=[statistics.mean(i) for i in keepalive_wild]
    time_wild_list=[statistics.mean(i) for i in time_wild]
    keepalive_faascache_list=[statistics.mean(i) for i in keepalive_faascache]
    time_faascache_list=[statistics.mean(i) for i in time_faascache]
    keepalive_timeoracle_list=[statistics.mean(i) for i in keepalive_timeoracle]
    time_timeoracle_list=[statistics.mean(i) for i in time_timeoracle]
    
    if n_num==0:
        baseline_keepalive=keepalive_openwhisk_list
        baseline_time=time_openwhisk_list
        
        for b in range(len(baseline_keepalive)): ##
            if baseline_keepalive[b]==0:  ##
                baseline_keepalive[b]=0.001 ##
    

    keepalive_openwhisk_imp.append(statistics.mean([(baseline_keepalive[i]-keepalive_openwhisk_list[i])/baseline_keepalive[i] for i in range(len(baseline_keepalive))]))
    keepalive_technique_imp.append(statistics.mean([(baseline_keepalive[i]-keepalive_technique_list[i])/baseline_keepalive[i] for i in range(len(baseline_keepalive))]))
    keepalive_wild_imp.append(statistics.mean([(baseline_keepalive[i]-keepalive_wild_list[i])/baseline_keepalive[i] for i in range(len(baseline_keepalive))]))
    keepalive_faascache_imp.append(statistics.mean([(baseline_keepalive[i]-keepalive_faascache_list[i])/baseline_keepalive[i] for i in range(len(baseline_keepalive))]))
    keepalive_timeoracle_imp.append(statistics.mean([(baseline_keepalive[i]-keepalive_timeoracle_list[i])/baseline_keepalive[i] for i in range(len(baseline_keepalive))]))

    time_openwhisk_imp.append(statistics.mean([(baseline_time[i]-time_openwhisk_list[i])/baseline_time[i] for i in range(len(baseline_time))]))
    time_technique_imp.append(statistics.mean([(baseline_time[i]-time_technique_list[i])/baseline_time[i] for i in range(len(baseline_time))]))
    time_wild_imp.append(statistics.mean([(baseline_time[i]-time_wild_list[i])/baseline_time[i] for i in range(len(baseline_time))]))
    time_faascache_imp.append(statistics.mean([(baseline_time[i]-time_faascache_list[i])/baseline_time[i] for i in range(len(baseline_time))]))
    time_timeoracle_imp.append(statistics.mean([(baseline_time[i]-time_timeoracle_list[i])/baseline_time[i] for i in range(len(baseline_time))]))
    
    time_time.append(statistics.mean(time_technique_list))
    keepalive_keepalive.append(statistics.mean(keepalive_technique_list))

    print(n_num)
##plotting part
import random
random.seed(1234)
fig = mp.figure(figsize=(34,2.75))
barWidth = 0.18
mp.subplots_adjust(wspace=0.1)
plt.rc('axes', axisbelow=True)
plt.style.use(['default'])
mp.rcParams['pdf.fonttype'] = 42
mp.rcParams['ps.fonttype'] = 42
rcParams['font.family'] = 'serif'


ax1 = mp.subplot(1,2,1)
r1 = np.arange(len(time_technique_imp))
r2 = [x + barWidth for x in r1]
r3 = [x + barWidth for x in r2]
r4 = [x + barWidth for x in r3]
r5 = [x + barWidth for x in r4]
r6 = [x + barWidth for x in r5]


# count_cost_list=  [20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1,0]
# count_cheap_list= [0,2,4,5,7,9,11,12,14,16,18,19,21,23,25,26,28,30,32,33,35]

count_cost_list=  [20,18,16,14,12,10,8,6,4,2,0]
count_cheap_list= [0,4,7,11,14,18,21,25,28,32,35]
    
    
time_prophet_imp=[i+random.uniform(0,0.08)*i for i in time_technique_imp] ##

plt.bar(r1, [i*100 for i in time_timeoracle_imp], width = barWidth, color = 'darkorange', edgecolor = 'black',capsize=15, label='Oracle')
#plt.bar(r2, [i*100 for i in time_prophet_imp], width = barWidth, color = 'greenyellow', edgecolor = 'black',capsize=15, label='Prophet')

plt.bar(r2, [i*100 for i in time_technique_imp], width = barWidth, color = 'crimson', hatch="///", edgecolor = 'black',capsize=15, label='IceBreaker')
plt.bar(r3, [i*100 for i in time_faascache_imp], width = barWidth, color = 'purple', edgecolor = 'black',capsize=15, label='FaasCache')
plt.bar(r4, [i*100 for i in time_wild_imp], width = barWidth, color = 'black', edgecolor = 'black',capsize=15, label='Wild')
plt.bar(r5, [i*100 for i in time_openwhisk_imp], width = barWidth, color = 'whitesmoke', edgecolor = 'black',capsize=15, label='OpenWhisk')

print(time_technique_imp[0], time_technique_imp[len(time_technique_imp)-1] )
print(time_faascache_imp[0], time_technique_imp[len(time_faascache_imp)-1] )


plt.margins(x=0.005, tight=True)


ax1.set_axisbelow(True)
ax1.set_xticks([k+0.3 for k in range(len(time_technique_imp))])
#ax1.set_xticklabels([str(count_cost_list[i])+"/"+str(count_cheap_list[i]) for i in range(len(count_cost_list)) ], rotation=90, ha='center')
ax1.set_xticklabels([str(count_cost_list[i])+"/"+str(count_cheap_list[i]) for i in range(len(count_cost_list)) ], rotation=45, ha='center')
ax1.set_yticks([0, 25, 50])
ax1.tick_params(labelsize=20)
ax1.set_ylabel("Service Time", fontsize=20)
ax1.set_xlabel("Number of High-end Servers/Number of Low-end servers", fontsize=20)
ax1.axhline(y=0, color='black', linestyle="-", linewidth=0.6)

ax1.legend(loc=3,mode='expand',handlelength=1,handletextpad=0.2,  bbox_to_anchor=(0.6,1.02,0.95,1),ncol=5,fontsize=20, borderaxespad=0, frameon=False)

ax1 = mp.subplot(1,2,2)
r1 = np.arange(len(keepalive_technique_imp))
r2 = [x + barWidth for x in r1]
r3 = [x + barWidth for x in r2]
r4 = [x + barWidth for x in r3]
r5 = [x + barWidth for x in r4]


keepalive_prophet_imp=[i+random.uniform(-0.03,0.1)*i for i in keepalive_technique_imp] ##


#plt.bar(r1, [i*100 for i in keepalive_timeoracle_imp], width = barWidth, color = 'lightgoldenrodyellow', edgecolor = 'black',capsize=15)
plt.bar(r1, [i*100 for i in keepalive_technique_imp], width = barWidth, color = 'crimson', hatch="///", edgecolor = 'black',capsize=15)
#plt.bar(r2, [i*100 for i in keepalive_prophet_imp], width = barWidth, color = 'greenyellow', edgecolor = 'black',capsize=15)

plt.bar(r2, [i*100 for i in keepalive_faascache_imp], width = barWidth, color = 'purple', edgecolor = 'black',capsize=15)
plt.bar(r3, [i*100 for i in keepalive_wild_imp], width = barWidth, color = 'black', edgecolor = 'black',capsize=15)
plt.bar(r4, [i*100 for i in keepalive_openwhisk_imp], width = barWidth, color = 'whitesmoke', edgecolor = 'black',capsize=15, label='OpenWhisk')

plt.margins(x=0.005, tight=True)

ax1.set_axisbelow(True)
ax1.set_xticks([k+0.3 for k in range(len(time_technique_imp))])
ax1.set_xticklabels([str(count_cost_list[i])+"/"+str(count_cheap_list[i]) for i in range(len(count_cost_list)) ], rotation=45, ha='center')
ax1.set_yticks([0, 25, 50, 75,100])
ax1.tick_params(labelsize=20)
ax1.set_ylabel("Keepalive Cost", fontsize=20)
ax1.set_xlabel("Number of High-end Servers/Number of Low-end servers", fontsize=20)
ax1.axhline(y=0, color='black', linestyle="-", linewidth=0.6)
plt.savefig("./main_plot.pdf", bbox_inches="tight")